Index: source/scriptinterface/ScriptInterface.cpp
===================================================================
--- source/scriptinterface/ScriptInterface.cpp	(Revision 14578)
+++ source/scriptinterface/ScriptInterface.cpp	(Arbeitskopie)
@@ -20,7 +20,6 @@
 #include "ScriptInterface.h"
 // #include "DebuggingServer.h" // JS debugger temporarily disabled during the SpiderMonkey upgrade (check trac ticket #2348 for details)
 #include "ScriptStats.h"
-#include "AutoRooters.h"
 
 #include "lib/debug.h"
 #include "lib/utf8.h"
@@ -68,12 +67,15 @@
 class ScriptRuntime
 {
 public:
-	ScriptRuntime(int runtimeSize) :
-		m_rooter(NULL)
+	ScriptRuntime(int runtimeSize)
 	{
-		m_rt = JS_NewRuntime(runtimeSize);
+		// TODO: check what JS_Init() actually does and what the constraints are
+		// What I know: It must be called before calling JS_NewRuntime
+		m_rt = JS_NewRuntime(runtimeSize, JS_USE_HELPER_THREADS);
+
 		ENSURE(m_rt); // TODO: error handling
 
+		JS_SetNativeStackQuota(m_rt, 128 * sizeof(size_t) * 1024);
 		if (g_ScriptProfilingEnabled)
 		{
 			// Profiler isn't thread-safe, so only enable this on the main thread
@@ -86,22 +88,26 @@
 				}
 			}
 		}
+		JS_SetGCParameter(m_rt, JSGC_MAX_MALLOC_BYTES, 256 * 1024 * 1024);
+		JS_SetGCParameter(m_rt, JSGC_MAX_BYTES, 256 * 1024 * 1024);
 
-		JS_SetExtraGCRoots(m_rt, jshook_trace, this);
+		m_dummyContext = JS_NewContext(m_rt, STACK_CHUNK_SIZE);
+		ENSURE(m_dummyContext);
 	}
 
 	~ScriptRuntime()
 	{
+		JS_DestroyContext(m_dummyContext);
 		JS_DestroyRuntime(m_rt);
 	}
 
+	JSContext* m_dummyContext;
 	JSRuntime* m_rt;
-	AutoGCRooter* m_rooter;
 
 private:
 
 
-	static void* jshook_script(JSContext* UNUSED(cx), JSStackFrame* UNUSED(fp), JSBool before, JSBool* UNUSED(ok), void* closure)
+	static void* jshook_script(JSContext* UNUSED(cx), JSAbstractFramePtr UNUSED(fp), bool UNUSED(isConstructing), JSBool before, JSBool* UNUSED(ok), void* closure)
 	{
 		if (before)
 			g_Profiler.StartScript("script invocation");
@@ -154,7 +160,7 @@
 			if (slash != filename.npos)
 				filename = filename.substr(slash+1);
 
-			uintN line = JS_PCToLineNumber(cx, script, pc);
+			uint line = JS_PCToLineNumber(cx, script, pc);
 
 			std::stringstream ss;
 			ss << "(" << filename << ":" << line << ")";
@@ -178,7 +184,7 @@
 		boost::flyweights::no_locking
 	> LocFlyweight;
 
-	static void* jshook_function(JSContext* cx, JSStackFrame* fp, JSBool before, JSBool* UNUSED(ok), void* closure)
+	static void* jshook_function(JSContext* cx, JSAbstractFramePtr fp, bool UNUSED(isConstructing), JSBool before, JSBool* UNUSED(ok), void* closure)
 	{
 		if (!before)
 		{
@@ -186,7 +192,7 @@
 			return closure;
 		}
 
-		JSFunction* fn = JS_GetFrameFunction(cx, fp);
+		JSFunction* fn = fp.maybeFun();
 		if (!fn)
 		{
 			g_Profiler.StartScript("(function)");
@@ -207,19 +213,15 @@
 		}
 
 		// No name - compute from the location instead
-		ScriptLocation loc = { cx, JS_GetFrameScript(cx, fp), JS_GetFramePC(cx, fp) };
+		JSScript* script;
+		unsigned lineno;
+		JS_DescribeScriptedCaller(cx, &script, &lineno);
+		ENSURE(script == fp.script());
+		ScriptLocation loc = { cx, fp.script(), JS_LineNumberToPC(cx, script, lineno) };
 		g_Profiler.StartScript(LocFlyweight(loc).get().name.c_str());
 
 		return closure;
 	}
-
-	static void jshook_trace(JSTracer* trc, void* data)
-	{
-		ScriptRuntime* m = static_cast<ScriptRuntime*>(data);
-
-		if (m->m_rooter)
-			m->m_rooter->Trace(trc);
-	}
 };
 
 shared_ptr<ScriptRuntime> ScriptInterface::CreateRuntime(int runtimeSize)
@@ -233,11 +235,13 @@
 {
 	ScriptInterface_impl(const char* nativeScopeName, const shared_ptr<ScriptRuntime>& runtime);
 	~ScriptInterface_impl();
-	void Register(const char* name, JSNative fptr, uintN nargs);
+	void Register(const char* name, JSNative fptr, uint nargs);
 
 	shared_ptr<ScriptRuntime> m_runtime;
 	JSContext* m_cx;
 	JSObject* m_glob; // global scope object
+	JSCompartment* m_comp;
+	boost::rand48* m_rng;
 	JSObject* m_nativeScope; // native function scope object
 };
 
@@ -246,19 +250,15 @@
 
 JSClass global_class = {
 	"global", JSCLASS_GLOBAL_FLAGS,
-	JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_StrictPropertyStub,
-	JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub, JS_FinalizeStub,
-	NULL, NULL, NULL, NULL,
+	JS_PropertyStub, JS_DeletePropertyStub, 
+	JS_PropertyStub, JS_StrictPropertyStub,
+	JS_EnumerateStub, JS_ResolveStub, 
+	JS_ConvertStub, NULL, 
 	NULL, NULL, NULL, NULL
 };
 
 void ErrorReporter(JSContext* cx, const char* message, JSErrorReport* report)
 {
-	// XXX Ugly hack: we want to compile code with 'use strict' and with JSOPTION_STRICT,
-	// but the latter causes the former to be reported as a useless expression, so
-	// ignore that specific warning here
-	if (report->flags == 5 && report->lineno == 0 && report->errorNumber == 163)
-		return;
 
 	std::stringstream msg;
 	bool isWarning = JSREPORT_IS_WARNING(report->flags);
@@ -273,7 +273,7 @@
 
 	// If there is an exception, then print its stack trace
 	jsval excn;
-	if (JS_GetPendingException(cx, &excn) && JSVAL_IS_OBJECT(excn))
+	if (JS_GetPendingException(cx, &excn) && !JSVAL_IS_PRIMITIVE(excn))
 	{
 		// TODO: this violates the docs ("The error reporter callback must not reenter the JSAPI.")
 
@@ -309,9 +309,9 @@
 
 // Functions in the global namespace:
 
-JSBool print(JSContext* cx, uintN argc, jsval* vp)
+JSBool print(JSContext* cx, uint argc, jsval* vp)
 {
-	for (uintN i = 0; i < argc; ++i)
+	for (uint i = 0; i < argc; ++i)
 	{
 		std::wstring str;
 		if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[i], str))
@@ -323,7 +323,7 @@
 	return JS_TRUE;
 }
 
-JSBool logmsg(JSContext* cx, uintN argc, jsval* vp)
+JSBool logmsg(JSContext* cx, uint argc, jsval* vp)
 {
 	if (argc < 1)
 	{
@@ -334,12 +334,12 @@
 	std::wstring str;
 	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], str))
 		return JS_FALSE;
-	LOGMESSAGE(L"%ls", str.c_str());
+	LOGMESSAGE(L"%ls%f", str.c_str(), timer_Time());
 	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
-JSBool warn(JSContext* cx, uintN argc, jsval* vp)
+JSBool warn(JSContext* cx, uint argc, jsval* vp)
 {
 	if (argc < 1)
 	{
@@ -355,7 +355,7 @@
 	return JS_TRUE;
 }
 
-JSBool error(JSContext* cx, uintN argc, jsval* vp)
+JSBool error(JSContext* cx, uint argc, jsval* vp)
 {
 	if (argc < 1)
 	{
@@ -371,7 +371,7 @@
 	return JS_TRUE;
 }
 
-JSBool deepcopy(JSContext* cx, uintN argc, jsval* vp)
+JSBool deepcopy(JSContext* cx, uint argc, jsval* vp)
 {
 	if (argc < 1)
 	{
@@ -381,21 +381,14 @@
 
 	jsval ret;
 
-	// We'd usually do:
-	//	if (!JS_StructuredClone(cx, JS_ARGV(cx, vp)[0], &ret, NULL, NULL))
-	//		return JS_FALSE;
-	// but that function is broken in the 1.8.5 release
-	// (https://bugzilla.mozilla.org/show_bug.cgi?id=651510)
-	// so do an equivalent operation with a different API:
-	JSAutoStructuredCloneBuffer buf;
-	if (!buf.write(cx, JS_ARGV(cx, vp)[0]) || !buf.read(&ret, cx))
+	if (!JS_StructuredClone(cx, JS_ARGV(cx, vp)[0], &ret, NULL, NULL))
 		return JS_FALSE;
 
 	JS_SET_RVAL(cx, vp, ret);
 	return JS_TRUE;
 }
 
-JSBool ProfileStart(JSContext* cx, uintN argc, jsval* vp)
+JSBool ProfileStart(JSContext* cx, uint argc, jsval* vp)
 {
 	const char* name = "(ProfileStart)";
 
@@ -423,7 +416,7 @@
 	return JS_TRUE;
 }
 
-JSBool ProfileStop(JSContext* UNUSED(cx), uintN UNUSED(argc), jsval* vp)
+JSBool ProfileStop(JSContext* UNUSED(cx), uint UNUSED(argc), jsval* vp)
 {
 	if (CProfileManager::IsInitialised() && ThreadUtil::IsMainThread())
 		g_Profiler.Stop();
@@ -452,33 +445,41 @@
 	}
 }
 
-JSBool Math_random(JSContext* cx, uintN UNUSED(argc), jsval* vp)
+JSBool Math_random(JSContext* cx, uint UNUSED(argc), jsval* vp)
 {
-	// Grab the RNG that was hidden in our slot
-	jsval rngp;
-	if (!JS_GetReservedSlot(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)), 0, &rngp))
+	double r;
+	if(!ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface->MathRandom(r))
+	{
 		return JS_FALSE;
-	boost::rand48* rng = static_cast<boost::rand48*>(JSVAL_TO_PRIVATE(rngp));
+	}
+	else
+	{
+		jsval rv = JS_NumberValue(r);
+		JS_SET_RVAL(cx, vp, rv);
+		return JS_TRUE;
+	}
+}
 
-	double r = generate_uniform_real(*rng, 0.0, 1.0);
+} // anonymous namespace
 
-	jsval rv;
-	if (!JS_NewNumberValue(cx, r, &rv))
-		return JS_FALSE;
-	JS_SET_RVAL(cx, vp, rv);
-	return JS_TRUE;
+bool ScriptInterface::MathRandom(double& nbr)
+{
+	if (m->m_rng == NULL)
+		return false;
+	nbr = generate_uniform_real(*(m->m_rng), 0.0, 1.0);
+	return true;
 }
 
-} // anonymous namespace
-
 ScriptInterface_impl::ScriptInterface_impl(const char* nativeScopeName, const shared_ptr<ScriptRuntime>& runtime) :
 	m_runtime(runtime)
 {
-	JSBool ok;
+	bool ok;
 
 	m_cx = JS_NewContext(m_runtime->m_rt, STACK_CHUNK_SIZE);
 	ENSURE(m_cx);
 
+	JS_SetParallelCompilationEnabled(m_cx, true);
+
 	// For GC debugging:
 	// JS_SetGCZeal(m_cx, 2);
 
@@ -486,9 +487,12 @@
 
 	JS_SetErrorReporter(m_cx, ErrorReporter);
 
-	uint32 options = 0;
-	options |= JSOPTION_STRICT; // "warn on dubious practice"
-	options |= JSOPTION_XML; // "ECMAScript for XML support: parse <!-- --> as a token"
+	uint32_t options = 0;
+	options |= JSOPTION_EXTRA_WARNINGS; // "warn on dubious practice"
+	// We use strict mode to encourage better coding practices and
+	//to get code that can be optimized better by Spidermonkey's JIT compiler.
+	options |= JSOPTION_STRICT_MODE;
+	//options |= JSOPTION_ALLOW_XML; // "ECMAScript for XML support: parse <!-- --> as a token"
 	options |= JSOPTION_VAROBJFIX; // "recommended" (fixes variable scoping)
 
 	// Enable method JIT, unless script profiling/debugging is enabled (since profiling/debugging
@@ -496,21 +500,31 @@
 	// TODO: Verify what exactly is incompatible
 	if (!g_ScriptProfilingEnabled && !g_JSDebuggerEnabled)
 	{
-		options |= JSOPTION_METHODJIT;
+		options |= JSOPTION_BASELINE;
+		options |= JSOPTION_ION;
+		options |= JSOPTION_TYPE_INFERENCE;
+		options |= JSOPTION_COMPILE_N_GO;
 
 		// Some other JIT flags to experiment with:
-		options |= JSOPTION_JIT;
-		options |= JSOPTION_PROFILING;
+		//options |= JSOPTION_METHODJIT_ALWAYS;
 	}
 
 	JS_SetOptions(m_cx, options);
-	JS_SetVersion(m_cx, JSVERSION_LATEST);
+	
+	JSAutoRequest rq(m_cx);
+	
+	JS::CompartmentOptions opt;
+	opt.setVersion(JSVERSION_LATEST);
+	m_glob = JS_NewGlobalObject(m_cx, &global_class, NULL, opt);
+	m_comp = JS_EnterCompartment(m_cx, m_glob);
+	JS_SetGlobalObject(m_cx, m_glob);
 
-	m_glob = JS_NewCompartmentAndGlobalObject(m_cx, &global_class, NULL);
-
 	ok = JS_InitStandardClasses(m_cx, m_glob);
 	ENSURE(ok);
+	
+	//JS_SetVersionForCompartment(m_comp, JSVERSION_LATEST);
 
+
 	JS_DefineProperty(m_cx, m_glob, "global", OBJECT_TO_JSVAL(m_glob), NULL, NULL, JSPROP_ENUMERATE | JSPROP_READONLY
 			| JSPROP_PERMANENT);
 
@@ -529,11 +543,16 @@
 
 ScriptInterface_impl::~ScriptInterface_impl()
 {
+	{
+		JSAutoRequest rq(m_cx);
+		JS_LeaveCompartment(m_cx, m_comp);
+	}
 	JS_DestroyContext(m_cx);
 }
 
-void ScriptInterface_impl::Register(const char* name, JSNative fptr, uintN nargs)
+void ScriptInterface_impl::Register(const char* name, JSNative fptr, uint nargs)
 {
+	JSAutoRequest rq(m_cx);
 	JSFunction* func = JS_DefineFunction(m_cx, m_nativeScope, name, fptr, nargs, JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
 
 	if (!func)
@@ -552,7 +571,7 @@
 		> LockedStringFlyweight;
 
 		LockedStringFlyweight fw(name);
-		JS_SetReservedSlot(m_cx, JS_GetFunctionObject(func), 0, PRIVATE_TO_JSVAL((void*)fw.get().c_str()));
+		JS_SetReservedSlot(JS_GetFunctionObject(func), 0, PRIVATE_TO_JSVAL((void*)fw.get().c_str()));
 	}
 }
 
@@ -599,6 +618,11 @@
 	JS_ShutDown();
 }
 
+void ScriptInterface::Tick()
+{
+	js::NotifyAnimationActivity(m->m_glob);
+}
+
 void ScriptInterface::SetCallbackData(void* pCBData)
 {
 	m_CxPrivate.pCBData = pCBData;
@@ -633,16 +657,16 @@
 
 bool ScriptInterface::ReplaceNondeterministicRNG(boost::rand48& rng)
 {
-	jsval math;
-	if (JS_GetProperty(m->m_cx, m->m_glob, "Math", &math) && JSVAL_IS_OBJECT(math))
+	JSAutoRequest rq(m->m_cx);
+	JS::RootedValue math(m->m_cx);
+	if (JS_GetProperty(m->m_cx, m->m_glob, "Math", math.address()) && !JSVAL_IS_PRIMITIVE(math.get()))
 	{
 		JSFunction* random = JS_DefineFunction(m->m_cx, JSVAL_TO_OBJECT(math), "random", Math_random, 0,
 			JSPROP_ENUMERATE | JSPROP_READONLY | JSPROP_PERMANENT);
 		if (random)
 		{
-			// Store the RNG in a slot which is sort-of-guaranteed to be unused by the JS engine
-			if (JS_SetReservedSlot(m->m_cx, JS_GetFunctionObject(random), 0, PRIVATE_TO_JSVAL(&rng)))
-				return true;
+			m->m_rng = &rng;
+			return true;
 		}
 	}
 
@@ -652,7 +676,7 @@
 
 void ScriptInterface::Register(const char* name, JSNative fptr, size_t nargs)
 {
-	m->Register(name, fptr, (uintN)nargs);
+	m->Register(name, fptr, (uint)nargs);
 }
 
 JSContext* ScriptInterface::GetContext() const
@@ -670,44 +694,45 @@
 	return m->m_runtime;
 }
 
-AutoGCRooter* ScriptInterface::ReplaceAutoGCRooter(AutoGCRooter* rooter)
-{
-	AutoGCRooter* ret = m->m_runtime->m_rooter;
-	m->m_runtime->m_rooter = rooter;
-	return ret;
-}
 
-
-jsval ScriptInterface::CallConstructor(jsval ctor, jsval arg)
+jsval ScriptInterface::CallConstructor(jsval ctor, int argc, jsval argv)
 {
-	if (!JSVAL_IS_OBJECT(ctor))
+	JSAutoRequest rq(m->m_cx);
+	if (JSVAL_IS_PRIMITIVE(ctor))
 	{
 		LOGERROR(L"CallConstructor: ctor is not an object");
 		return JSVAL_VOID;
 	}
 
-	return OBJECT_TO_JSVAL(JS_New(m->m_cx, JSVAL_TO_OBJECT(ctor), 1, &arg));
+	// Passing argc 0 and argv JSVAL_VOID causes a crash in mozjs24
+	if (argc == 0)
+	{
+		return OBJECT_TO_JSVAL(JS_New(m->m_cx, JSVAL_TO_OBJECT(ctor), 0, NULL));
+	}
+	else
+		return OBJECT_TO_JSVAL(JS_New(m->m_cx, JSVAL_TO_OBJECT(ctor), argc, &argv));
 }
 
 jsval ScriptInterface::NewObjectFromConstructor(jsval ctor)
 {
+	JSAutoRequest rq(m->m_cx);
 	// Get the constructor's prototype
 	// (Can't use JS_GetPrototype, since we want .prototype not .__proto__)
-	jsval protoVal;
-	if (!JS_GetProperty(m->m_cx, JSVAL_TO_OBJECT(ctor), "prototype", &protoVal))
+	JS::RootedValue protoVal(m->m_cx);
+	if (!JS_GetProperty(m->m_cx, JSVAL_TO_OBJECT(ctor), "prototype", protoVal.address()))
 	{
 		LOGERROR(L"NewObjectFromConstructor: can't get prototype");
 		return JSVAL_VOID;
 	}
 
-	if (!JSVAL_IS_OBJECT(protoVal))
+	if (JSVAL_IS_PRIMITIVE(protoVal.get()))
 	{
 		LOGERROR(L"NewObjectFromConstructor: prototype is not an object");
 		return JSVAL_VOID;
 	}
 
-	JSObject* proto = JSVAL_TO_OBJECT(protoVal);
-	JSObject* parent = JS_GetParent(m->m_cx, JSVAL_TO_OBJECT(ctor));
+	JSObject* proto = JSVAL_TO_OBJECT(protoVal.get());
+	JSObject* parent = JS_GetParent(JSVAL_TO_OBJECT(ctor));
 	// TODO: rooting?
 	if (!proto || !parent)
 	{
@@ -727,6 +752,7 @@
 
 void ScriptInterface::DefineCustomObjectType(JSClass *clasp, JSNative constructor, uint minArgs, JSPropertySpec *ps, JSFunctionSpec *fs, JSPropertySpec *static_ps, JSFunctionSpec *static_fs)
 {
+	JSAutoRequest rq(m->m_cx);
 	std::string typeName = clasp->name;
 
 	if (m_CustomObjectTypes.find(typeName) != m_CustomObjectTypes.end())
@@ -774,6 +800,7 @@
 
 bool ScriptInterface::CallFunction_(jsval val, const char* name, size_t argc, jsval* argv, jsval& ret)
 {
+	JSAutoRequest rq(m->m_cx);
 	JSObject* obj;
 	if (!JS_ValueToObject(m->m_cx, val, &obj) || obj == NULL)
 		return false;
@@ -782,16 +809,17 @@
 	// when calling an undefined value
 	JSBool found;
 	if (!JS_HasProperty(m->m_cx, obj, name, &found) || !found)
-		return false;
+		return JS_FALSE;
 
-	JSBool ok = JS_CallFunctionName(m->m_cx, obj, name, (uintN)argc, argv, &ret);
+	bool ok = JS_CallFunctionName(m->m_cx, obj, name, (uint)argc, argv, &ret);
 
-	return ok ? true : false;
+	return ok ? JS_TRUE : JS_FALSE;
 }
 
 jsval ScriptInterface::GetGlobalObject()
 {
-	return OBJECT_TO_JSVAL(JS_GetGlobalObject(m->m_cx));
+	JSAutoRequest rq(m->m_cx);
+	return OBJECT_TO_JSVAL(JS_GetGlobalForScopeChain(m->m_cx));
 }
 
 JSClass* ScriptInterface::GetGlobalClass()
@@ -801,32 +829,34 @@
 
 bool ScriptInterface::SetGlobal_(const char* name, jsval value, bool replace)
 {
+	JSAutoRequest rq(m->m_cx);
 	if (!replace)
 	{
 		JSBool found;
 		if (!JS_HasProperty(m->m_cx, m->m_glob, name, &found))
-			return false;
+			return JS_FALSE;
 		if (found)
 		{
 			JS_ReportError(m->m_cx, "SetGlobal \"%s\" called multiple times", name);
-			return false;
+			return JS_FALSE;
 		}
 	}
 
-	JSBool ok = JS_DefineProperty(m->m_cx, m->m_glob, name, value, NULL, NULL, JSPROP_ENUMERATE | JSPROP_READONLY
-			| JSPROP_PERMANENT);
-	return ok ? true : false;
+	bool ok = JS_DefineProperty(m->m_cx, m->m_glob, name, value, NULL, NULL, JSPROP_ENUMERATE | JSPROP_READONLY
+ 			| JSPROP_PERMANENT);
+	return ok ? JS_TRUE : JS_FALSE;
 }
 
 bool ScriptInterface::SetProperty_(jsval obj, const char* name, jsval value, bool constant, bool enumerate)
 {
-	uintN attrs = 0;
+	JSAutoRequest rq(m->m_cx);
+	uint attrs = 0;
 	if (constant)
 		attrs |= JSPROP_READONLY | JSPROP_PERMANENT;
 	if (enumerate)
 		attrs |= JSPROP_ENUMERATE;
 
-	if (! JSVAL_IS_OBJECT(obj))
+	if (JSVAL_IS_PRIMITIVE(obj))
 		return false;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
@@ -837,13 +867,14 @@
 
 bool ScriptInterface::SetProperty_(jsval obj, const wchar_t* name, jsval value, bool constant, bool enumerate)
 {
-	uintN attrs = 0;
+	JSAutoRequest rq(m->m_cx);
+	uint attrs = 0;
 	if (constant)
 		attrs |= JSPROP_READONLY | JSPROP_PERMANENT;
 	if (enumerate)
 		attrs |= JSPROP_ENUMERATE;
 
-	if (! JSVAL_IS_OBJECT(obj))
+	if ( JSVAL_IS_PRIMITIVE(obj))
 		return false;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
@@ -855,13 +886,14 @@
 
 bool ScriptInterface::SetPropertyInt_(jsval obj, int name, jsval value, bool constant, bool enumerate)
 {
-	uintN attrs = 0;
+	JSAutoRequest rq(m->m_cx);
+	uint attrs = 0;
 	if (constant)
 		attrs |= JSPROP_READONLY | JSPROP_PERMANENT;
 	if (enumerate)
 		attrs |= JSPROP_ENUMERATE;
 
-	if (! JSVAL_IS_OBJECT(obj))
+	if ( JSVAL_IS_PRIMITIVE(obj))
 		return false;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
@@ -870,48 +902,54 @@
 	return true;
 }
 
-bool ScriptInterface::GetProperty_(jsval obj, const char* name, jsval& out)
+bool ScriptInterface::GetProperty_(jsval obj, const char* name, JS::MutableHandleValue out)
 {
-	if (! JSVAL_IS_OBJECT(obj))
+	JSAutoRequest rq(m->m_cx);
+	if ( JSVAL_IS_PRIMITIVE(obj))
 		return false;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
-	if (!JS_GetProperty(m->m_cx, object, name, &out))
+	if (!JS_GetProperty(m->m_cx, object, name, out.address()))
 		return false;
 	return true;
 }
 
-bool ScriptInterface::GetPropertyInt_(jsval obj, int name, jsval& out)
+bool ScriptInterface::GetPropertyInt_(jsval obj, int name, JS::MutableHandleValue out)
 {
-	if (! JSVAL_IS_OBJECT(obj))
+	JSAutoRequest rq(m->m_cx);
+	if ( JSVAL_IS_PRIMITIVE(obj))
 		return false;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
-	if (!JS_GetPropertyById(m->m_cx, object, INT_TO_JSID(name), &out))
+	if (!JS_GetPropertyById(m->m_cx, object, INT_TO_JSID(name), out.address()))
 		return false;
 	return true;
 }
 
 bool ScriptInterface::HasProperty(jsval obj, const char* name)
 {
-	if (! JSVAL_IS_OBJECT(obj))
-		return false;
+	// TODO: proper errorhandling 
+	JSAutoRequest rq(m->m_cx);
+	if ( JSVAL_IS_PRIMITIVE(obj))
+		return JS_FALSE;
 	JSObject* object = JSVAL_TO_OBJECT(obj);
 
 	JSBool found;
 	if (!JS_HasProperty(m->m_cx, object, name, &found))
-		return false;
-	return (found != JS_FALSE);
+		return JS_FALSE;
+	return found;
 }
 
-bool ScriptInterface::EnumeratePropertyNamesWithPrefix(jsval obj, const char* prefix, std::vector<std::string>& out)
+bool ScriptInterface::EnumeratePropertyNamesWithPrefix(JS::HandleObject obj, const char* prefix, std::vector<std::string>& out)
 {
-	utf16string prefix16 (prefix, prefix+strlen(prefix));
+	JSAutoRequest rq(m->m_cx);
+	if (obj.get() == 0x0)
+		return true;
 
-	if (! JSVAL_IS_OBJECT(obj))
-		return false; // TODO: log error messages
+//	if ( obj.get().isPrimitive() )
+//		return false; // TODO: log error messages
 
-	JSObject* it = JS_NewPropertyIterator(m->m_cx, JSVAL_TO_OBJECT(obj));
+	JSObject* it = JS_NewPropertyIterator(m->m_cx, obj.get());
 	if (!it)
 		return false;
 
@@ -927,33 +965,45 @@
 			continue; // ignore integer properties
 
 		JSString* name = JSVAL_TO_STRING(val);
-		size_t len;
-		const jschar* chars = JS_GetStringCharsAndLength(m->m_cx, name, &len);
-		if (chars && len >= prefix16.size() && memcmp(chars, prefix16.c_str(), prefix16.size()*2) == 0)
-			out.push_back(std::string(chars, chars+len)); // handles Unicode poorly
+		size_t len = strlen(prefix)+1;
+		char buf[len];
+		size_t prefixLen = strlen(prefix) * sizeof(char);
+		JS_EncodeStringToBuffer(m->m_cx, name, buf, prefixLen);
+		buf[len-1]= '\0';
+		if(0 == strcmp(buf, prefix))
+		{
+			size_t len;
+			const jschar* chars = JS_GetStringCharsAndLength(m->m_cx, name, &len);
+			out.push_back(std::string(chars, chars+len));
+		}
+//		if (chars && len >= prefix16.size() && memcmp(chars, prefix16.c_str(), prefix16.size()*2) == 0)
+//			out.push_back(std::string(chars, chars+len)); // handles Unicode poorly
+
 	}
 
 	// Recurse up the prototype chain
-	JSObject* prototype = JS_GetPrototype(m->m_cx, JSVAL_TO_OBJECT(obj));
-	if (prototype)
+	JS::RootedObject prototype(m->m_cx);
+	if (JS_GetPrototype(m->m_cx, obj, prototype.address()))
 	{
-		if (! EnumeratePropertyNamesWithPrefix(OBJECT_TO_JSVAL(prototype), prefix, out))
+		if (! EnumeratePropertyNamesWithPrefix(prototype, prefix, out))
 			return false;
 	}
 
 	return true;
 }
 
-bool ScriptInterface::SetPrototype(jsval obj, jsval proto)
+bool ScriptInterface::SetPrototype(JS::HandleObject obj, JS::HandleObject proto)
 {
-	if (!JSVAL_IS_OBJECT(obj) || !JSVAL_IS_OBJECT(proto))
-		return false;
-	return JS_SetPrototype(m->m_cx, JSVAL_TO_OBJECT(obj), JSVAL_TO_OBJECT(proto)) ? true : false;
+	JSAutoRequest rq(m->m_cx);
+	//if (JSVAL_IS_PRIMITIVE(obj) || JSVAL_IS_PRIMITIVE(proto))
+	//	return false;
+	return JS_SetPrototype(m->m_cx, obj, proto);
 }
 
 bool ScriptInterface::FreezeObject(jsval obj, bool deep)
 {
-	if (!JSVAL_IS_OBJECT(obj))
+	JSAutoRequest rq(m->m_cx);
+	if (JSVAL_IS_PRIMITIVE(obj))
 		return false;
 
 	if (deep)
@@ -964,43 +1014,41 @@
 
 bool ScriptInterface::LoadScript(const VfsPath& filename, const std::string& code)
 {
-	// Compile the code in strict mode, to encourage better coding practices and
-	// to possibly help SpiderMonkey with optimisations
-	std::wstring codeStrict = L"\"use strict\";\n" + wstring_from_utf8(code);
-	utf16string codeUtf16(codeStrict.begin(), codeStrict.end());
-	uintN lineNo = 0; // put the automatic 'use strict' on line 0, so the real code starts at line 1
+	JSAutoRequest rq(m->m_cx);
+	utf16string codeUtf16(code.begin(), code.end());
+	uint lineNo = 1;
 
-	JSFunction* func = JS_CompileUCFunction(m->m_cx, NULL, NULL, 0, NULL,
-			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uintN)(codeUtf16.length()),
-			utf8_from_wstring(filename.string()).c_str(), lineNo);
-
+	JS::Rooted<JSFunction*> func(m->m_cx,
+		JS_CompileUCFunction(m->m_cx, m->m_glob, utf8_from_wstring(filename.string()).c_str(), 0, NULL,
+			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uint)(codeUtf16.length()),
+			utf8_from_wstring(filename.string()).c_str(), lineNo)
+	);
 	if (!func)
 		return false;
 
-	jsval scriptRval;
-	JSBool ok = JS_CallFunction(m->m_cx, NULL, func, 0, NULL, &scriptRval);
+	JS::RootedValue val(m->m_cx);
+	bool ok = JS_CallFunction(m->m_cx, NULL, func, 0, NULL, val.address());
 
 	return ok ? true : false;
 }
 
 bool ScriptInterface::LoadGlobalScript(const VfsPath& filename, const std::wstring& code)
 {
-	// Compile the code in strict mode, to encourage better coding practices and
-	// to possibly help SpiderMonkey with optimisations
-	std::wstring codeStrict = L"\"use strict\";\n" + code;
-	utf16string codeUtf16(codeStrict.begin(), codeStrict.end());
-	uintN lineNo = 0; // put the automatic 'use strict' on line 0, so the real code starts at line 1
+	JSAutoRequest rq(m->m_cx);
+	utf16string codeUtf16(code.begin(), code.end());
+	uint lineNo = 1;
 
 	jsval rval;
-	JSBool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob,
-			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uintN)(codeUtf16.length()),
+	bool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob,
+			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uint)(codeUtf16.length()),
 			utf8_from_wstring(filename.string()).c_str(), lineNo, &rval);
 
-	return ok ? true : false;
+	return ok;
 }
 
 bool ScriptInterface::LoadGlobalScriptFile(const VfsPath& path)
 {
+	JSAutoRequest rq(m->m_cx);
 	if (!VfsFileExists(path))
 	{
 		LOGERROR(L"File '%ls' does not exist", path.string().c_str());
@@ -1019,18 +1067,15 @@
 
 	std::wstring code = wstring_from_utf8(file.DecodeUTF8()); // assume it's UTF-8
 
-	// Compile the code in strict mode, to encourage better coding practices and
-	// to possibly help SpiderMonkey with optimisations
-	std::wstring codeStrict = L"\"use strict\";\n" + code;
-	utf16string codeUtf16(codeStrict.begin(), codeStrict.end());
-	uintN lineNo = 0; // put the automatic 'use strict' on line 0, so the real code starts at line 1
+	utf16string codeUtf16(code.begin(), code.end());
+	uint lineNo = 1;
 
 	jsval rval;
-	JSBool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob,
-			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uintN)(codeUtf16.length()),
+	bool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob,
+			reinterpret_cast<const jschar*> (codeUtf16.c_str()), (uint)(codeUtf16.length()),
 			utf8_from_wstring(path.string()).c_str(), lineNo, &rval);
 
-	return ok ? true : false;
+	return ok;
 }
 
 
@@ -1042,45 +1087,29 @@
 
 bool ScriptInterface::Eval_(const char* code, jsval& rval)
 {
+	JSAutoRequest rq(m->m_cx);
 	utf16string codeUtf16(code, code+strlen(code));
 
-	JSBool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob, (const jschar*)codeUtf16.c_str(), (uintN)codeUtf16.length(), "(eval)", 1, &rval);
-	return ok ? true : false;
+	bool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob, (const jschar*)codeUtf16.c_str(), (uint)codeUtf16.length(), "(eval)", 1, &rval);
+	return ok;
 }
 
 bool ScriptInterface::Eval_(const wchar_t* code, jsval& rval)
 {
+	JSAutoRequest rq(m->m_cx);
 	utf16string codeUtf16(code, code+wcslen(code));
 
-	JSBool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob, (const jschar*)codeUtf16.c_str(), (uintN)codeUtf16.length(), "(eval)", 1, &rval);
-	return ok ? true : false;
+	bool ok = JS_EvaluateUCScript(m->m_cx, m->m_glob, (const jschar*)codeUtf16.c_str(), (uint)codeUtf16.length(), "(eval)", 1, &rval);
+	return ok;
 }
 
 CScriptValRooted ScriptInterface::ParseJSON(const std::string& string_utf8)
 {
+	JSAutoRequest rq(m->m_cx);
 	std::wstring attrsW = wstring_from_utf8(string_utf8);
-	utf16string string(attrsW.begin(), attrsW.end());
-
-	jsval vp;
-	JSONParser* parser = JS_BeginJSONParse(m->m_cx, &vp);
-	if (!parser)
-	{
-		LOGERROR(L"ParseJSON failed to begin");
-		return CScriptValRooted();
-	}
-
-	if (!JS_ConsumeJSONText(m->m_cx, parser, reinterpret_cast<const jschar*>(string.c_str()), (uint32)string.size()))
-	{
-		LOGERROR(L"ParseJSON failed to consume");
-		return CScriptValRooted();
-	}
-
-	if (!JS_FinishJSONParse(m->m_cx, parser, JSVAL_NULL))
-	{
-		LOGERROR(L"ParseJSON failed to finish");
-		return CScriptValRooted();
-	}
-
+ 	utf16string string(attrsW.begin(), attrsW.end());
+	JS::Rooted<jsval> vp(m->m_cx);
+	JS_ParseJSON(m->m_cx, reinterpret_cast<const jschar*>(string.c_str()), (uint32_t)string.size(), &vp);
 	return CScriptValRooted(m->m_cx, vp);
 }
 
@@ -1109,7 +1138,7 @@
 
 struct Stringifier
 {
-	static JSBool callback(const jschar* buf, uint32 len, void* data)
+	static JSBool callback(const jschar* buf, uint32_t len, void* data)
 	{
 		utf16string str(buf, buf+len);
 		std::wstring strw(str.begin(), str.end());
@@ -1124,7 +1153,7 @@
 
 struct StringifierW
 {
-	static JSBool callback(const jschar* buf, uint32 len, void* data)
+	static JSBool callback(const jschar* buf, uint32_t len, void* data)
 	{
 		utf16string str(buf, buf+len);
 		static_cast<StringifierW*>(data)->stream << std::wstring(str.begin(), str.end());
@@ -1136,6 +1165,7 @@
 
 std::string ScriptInterface::StringifyJSON(jsval obj, bool indent)
 {
+	JSAutoRequest rq(m->m_cx);
 	Stringifier str;
 	if (!JS_Stringify(m->m_cx, &obj, NULL, indent ? INT_TO_JSVAL(2) : JSVAL_VOID, &Stringifier::callback, &str))
 	{
@@ -1151,6 +1181,7 @@
 
 std::wstring ScriptInterface::ToString(jsval obj, bool pretty)
 {
+	JSAutoRequest rq(m->m_cx);
 	if (JSVAL_IS_VOID(obj))
 		return L"(void 0)";
 
@@ -1163,7 +1194,7 @@
 		// Temporary disable the error reporter, so we don't print complaints about cyclic values
 		JSErrorReporter er = JS_SetErrorReporter(m->m_cx, NULL);
 
-		bool ok = JS_Stringify(m->m_cx, &obj, NULL, INT_TO_JSVAL(2), &StringifierW::callback, &str) == JS_TRUE;
+		JSBool ok = JS_Stringify(m->m_cx, &obj, NULL, INT_TO_JSVAL(2), &StringifierW::callback, &str);
 
 		// Restore error reporter
 		JS_SetErrorReporter(m->m_cx, er);
@@ -1185,6 +1216,7 @@
 
 void ScriptInterface::ReportError(const char* msg)
 {
+	JSAutoRequest rq(m->m_cx);
 	// JS_ReportError by itself doesn't seem to set a JS-style exception, and so
 	// script callers will be unable to catch anything. So use JS_SetPendingException
 	// to make sure there really is a script-level exception. But just set it to undefined
@@ -1198,29 +1230,28 @@
 
 bool ScriptInterface::IsExceptionPending(JSContext* cx)
 {
+	JSAutoRequest rq(cx);
 	return JS_IsExceptionPending(cx) ? true : false;
 }
 
-JSClass* ScriptInterface::GetClass(JSContext* cx, JSObject* obj)
+JSClass* ScriptInterface::GetClass(JSObject* obj)
 {
-	UNUSED2(cx); // unused if not JS_THREADSAFE
-
-	return JS_GET_CLASS(cx, obj);
+	return JS_GetClass(obj);
 }
 
-void* ScriptInterface::GetPrivate(JSContext* cx, JSObject* obj)
+void* ScriptInterface::GetPrivate(JSObject* obj)
 {
 	// TODO: use JS_GetInstancePrivate
-	return JS_GetPrivate(cx, obj);
+	return JS_GetPrivate(obj);
 }
 
 void ScriptInterface::DumpHeap()
 {
 #if MOZJS_DEBUG_ABI
-	JS_DumpHeap(m->m_cx, stderr, NULL, 0, NULL, (size_t)-1, NULL);
+	JS_DumpHeap(GetJSRuntime(), stderr, NULL, JSTRACE_OBJECT, NULL, (size_t)-1, NULL);
 #endif
 	fprintf(stderr, "# Bytes allocated: %u\n", JS_GetGCParameter(GetJSRuntime(), JSGC_BYTES));
-	JS_GC(m->m_cx);
+	JS_GC(GetJSRuntime());
 	fprintf(stderr, "# Bytes allocated after GC: %u\n", JS_GetGCParameter(GetJSRuntime(), JSGC_BYTES));
 }
 
@@ -1233,7 +1264,7 @@
 {
 public:
 	ValueCloner(ScriptInterface& from, ScriptInterface& to) :
-		scriptInterfaceFrom(from), cxFrom(from.GetContext()), cxTo(to.GetContext()), m_RooterFrom(from), m_RooterTo(to)
+		scriptInterfaceFrom(from), cxFrom(from.GetContext()), cxTo(to.GetContext()), m_RooterFrom(from.GetContext()), m_RooterTo(to.GetContext())
 	{
 	}
 
@@ -1247,7 +1278,7 @@
 		if (it != m_Mapping.end())
 			return it->second;
 
-		m_RooterFrom.Push(val); // root it so our mapping doesn't get invalidated
+		m_RooterFrom.append(val); // root it so our mapping doesn't get invalidated
 
 		return Clone(val);
 	}
@@ -1259,11 +1290,12 @@
 	// Clone a new value (and root it and add it to the mapping)
 	jsval Clone(jsval val)
 	{
+		JSAutoRequest rq(cxFrom);
 		if (JSVAL_IS_DOUBLE(val))
 		{
-			jsval rval;
-			CLONE_REQUIRE(JS_NewNumberValue(cxTo, JSVAL_TO_DOUBLE(val), &rval), L"JS_NewNumberValue");
-			m_RooterTo.Push(rval);
+			jsval rval = JS_NumberValue(JSVAL_TO_DOUBLE(val));
+			CLONE_REQUIRE(!JSVAL_IS_VOID(rval), L"JS_NumberValue");
+			m_RooterTo.append(rval);
 			return rval;
 		}
 
